Subject: Re: [net-next PATCH] octeontx2-af: Workaround SQM/PSE stalls by disabling sticky

From: Simon Horman <[email-masked]>
Date: Thu, 29 Jan 2026 13:09:18 +0000

On Tue, Jan 27, 2026 at 06:21:47PM +0530, Geetha sowjanya wrote:
> NIX SQ manager sticky mode is known to cause stalls when multiple SQs
> share an SMQ and transmit concurrently. Additionally, PSE may deadlock
> on transitions between sticky and non-sticky transmissions. There is
> also a credit drop issue observed when certain condition clocks are
> gated.
> 
> work around these hardware errata by:
> - Disabling SQM sticky operation:
>   - Clear TM6 (bit 15)
>   - Clear TM11 (bit 14)
> - Disabling sticky → non-sticky transition path that can deadlock PSE:
>   - Clear TM5 (bit 23)
> - Preventing credit drops by keeping the control-flow clock enabled:
>   - Set TM9 (bit 21)
> 
> These changes are applied via NIX_AF_SQM_DBG_CTL_STATUS. With this
> configuration the SQM/PSE maintain forward progress under load without
> credit loss, at the cost of disabling sticky optimizations.
> 
> Signed-off-by: Geetha sowjanya <[email-masked]>

I didn't look over the rest of the driver, but it strikes me that the code
touched by this patch could benefit from some defines for the bits of cfg.

But I don't think that needs to block progress of this patch.

Reviewed-by: Simon Horman <[email-masked]>

...